10 'TEXTER/BAS by Andy Levinson
110 '11575 sunshine Terrace, Studio City CA 91604-3835
120 'Released to Public Domain - 9/6/85
130 ' 
140 'Splits ASCII files into formatted lines. File must
150 'end with a zero byte. Preserves existing line feeds
160 'and carriage returns. Avoids splitting words while
170 'eliminating leading spaces at splits. Note that the
180 'end line length is ONE LESS to allow for a carriage
190 'return character at the end of each line.
200 '
210 'For the Model's I, III, and 4/4P. For native Model 
220 '4 mode, change > 106 < in Line 530 to > 53 <
230 '        change > :CMD"E" < in Line 710 to > ERRS$ <
240 '
250 '=== Initialize Variables ===
260 CLEAR 300:DEFINT A-Z
270 DIM B, X, W$, M, S, R, F, S$, P$, N, W, D$(1)
280 '
290 N=20        'Narrowest line length available
300 W=200       'Widest line length avaible
310 S=7         'Hot Zone - # to start looking to split lines
320 '            Set higher or lower as needed or desired.
330 '
340 '=== Introduction (important - don't skip this) ===
350 CLS:PRINT, "Mini-Text Converter by Andy Levinson":PRINT
360 PRINT "Adds carriage returns at line ends and tries to"
370 PRINT "split lines at spaces. Very simple but it works."
380 PRINT:PRINT, "Press <ENTER> alone to quit":PRINT
390 '
400 '=== Get Valid Line Length ===
410 M=0:INPUT "Maximum line length";M
420 IF M=0 THEN 750 ELSE IF M>=N AND M<=W THEN 470
430 PRINT, "Length must be between";N;"and";W;"characters."
440 FOR X=1 TO 2000:NEXT X:GOTO 360     'Delay Loop
450 '
460 '=== Get Source and Destination File Names ===
470 S$="":LINE INPUT "Source File Name:  ";S$:IF S$="" THEN 750
480 P$="":LINE INPUT "Output File Name:  ";P$:IF P$="" THEN 750
490 IF P$=S$ THEN PRINT, "Names must be different.":GOTO 440
500 '
510 '=== Set Error Traps - Open Files - Field Variables ===
520 ON ERROR GOTO 530:OPEN "I",1,S$:CLOSE:GOTO 550
530 IF ERR<>106 THEN GOTO 710 ELSE RESUME 540
540 PRINT, "Input File Does Not Exist!":GOTO 440
550 ON ERROR GOTO 710:OPEN "R", 1, S$:OPEN "O", 2, P$
560 FIELD 1, 128 AS D$(0), 128 AS D$(1):R=1:X=128:M=M-1:F=0
570 '
580 '===Main Loop - Build New Line One Byte at a Time ===
590 PRINT:W$=""         'New line starts blank
600 GOSUB 670           'Get a byte
610 IF F=1 THEN IF B=10 OR B=13 OR B=32 THEN F=0:GOTO 600
620 F=0:IF B=0 OR B=10 OR B=13 OR B=32 AND LEN(W$)>M-S THEN 640
630 W$=W$+CHR$(B):PRINT CHR$(B);:IF LEN(W$)<M THEN 600 ELSE F=1
640 PRINT #2, W$:IF B>0 THEN 590 ELSE 750
650 '
660 '=== Subroutine to Get Next Byte - Read File if Needed ===
670 X=X+1:IF X=129 THEN R=R+1:X=1:IF R=2 THEN GET 1:R=0
680 B=ASC(MID$(D$(R),X,1)):RETURN
690 '
700 '=== Error Trap - Ends Program ===
710 PRINT, :CMD"E":RESUME 720
720 PRINT, "Aborting on error."
730 '
740 '=== End of Program Routine ===
750 ON ERROR GOTO 0:CLOSE:PRINT:PRINT, "ALL DONE!";:PRINT:END
760 '
770 '=== End of Listing ===
